'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = curry;
/**
 * Curry wrapper function.
 * @param {function} fn - Function that will be wrapped within curry.
 * @return {function}
 */
function curry(fn) {
  return function () {
    for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
      params[_key] = arguments[_key];
    }

    if (params.length === 0) {
      throw Error('EMPTY INVOCATION');
    }

    if (params.length >= fn.length) {
      return fn.apply(undefined, params);
    }

    return curry(fn.bind.apply(fn, [null].concat(params)));
  };
}